#### 配置管理
##### LDAP认证设置
【系统管理】-> 【全局安全设置】-> 【Active Directory】，如下
![](https://wiki.51itop.cn/uploads/ci/images/m_2b133f900a41acd714f6200ace01f8c0_r.png)

------------


设置AD用户登录后的权限
![](https://wiki.51itop.cn/uploads/ci/images/m_d85c830f5f88d07b0c7ca7492c5226d9_r.png)

##### 添加凭据
###### 添加gitlab凭据
1、【凭据】->【jenkins】->【全局凭据】->【Add Credentials】,私钥添加到jenkins下，如下图：
![](https://wiki.51itop.cn/uploads/ci/images/m_55e023b0d13fefb00cc1d0478cf97c89_r.png)
2、公钥添加到gitlab下，如下图：
![](https://wiki.51itop.cn/uploads/ci/images/m_97d3c0d1897de36c8aa103ff5cb0de69_r.png)

------------


###### 添加salt-api凭据
1、在此实验环境下，jenkins跟salt是在同一台机器上的，所以在此机器上安装械salt-api，步骤如下：
1)、安装salt-api `yum -y install salt-api`
2)、检查cherry包是否安装了`rpm -qa |grep  cherry`
3)、创建saltapi帐户并设置密码
`useradd -M -s /sbin/nologin saltapi`
`echo "saltapi" | passwd saltapi --stdin`
4)、创建salt-api的配置文件，认证用户就用步骤3创建的用户
```shell
[root@test11 ~]# cat /etc/salt/master.d/salt-api.conf
external_auth:
  pam:
    saltapi:
      - .*
      - '@runner'

rest_cherrypy:
  port: 8001
  disable_ssl: true       #关闭ssl认证
```
5)、验证salt-api是否配置正确：
```shell
[root@test11 ~]# curl -sSk http://127.0.0.1:8001/login \
> -H 'Accept: application/x-yaml' \
> -d username='saltapi' \
> -d password='saltapi' \
> -d eauth='pam'
```
6)、重启salt-api和salt-master
`systemctl restart salt-master`
`systemctl restart salt-api`
7)、在jenkins上添加salt-api的凭据，如下：
![](https://wiki.51itop.cn/uploads/ci/images/m_e91f211b65ad66639f9dbbd855c43c57_r.png)

##### 系统设置
1、【系统管理】-> 【系统设置】，设置标题，如下：
![](https://wiki.51itop.cn/uploads/ci/images/m_91a2b2e503036bcecbddbf3d03606702_r.png)

2、【系统管理】-> 【系统设置】，添加sonarqube,如下：
1)、先在sonarqube中生成token
![](https://wiki.51itop.cn/uploads/ci/images/m_20d9db325d46f7c6490217cc70f1c709_r.png)
2)、把生成的token添加到jenkins上
![](https://wiki.51itop.cn/uploads/ci/images/m_23a9575a50bbf206fdd1e75c83503c57_r.png)
![](https://wiki.51itop.cn/uploads/ci/images/m_c54dcc6cfa090e7b4d42e60fb2c0f338_r.png)

3、配置gitlab
![](https://wiki.51itop.cn/uploads/ci/images/m_203d7e45df2abf2a98599aac960ad948_r.png)

##### 全局工具设置
添加jenkins构建工具，例如maven,go,sonarqube scaner等，如下：
![](https://wiki.51itop.cn/uploads/ci/images/m_982884b8a92c70a0cb61bc71ca1bea44_r.png)