##### 关于sonarqube
SonarQube（曾用名Sonar（声纳）[1]）是一个开源的代码质量管理系统。支持超过25种编程语言[2]：Java、C/C++、C#、PHP、Flex、Groovy、JavaScript、Python、PL/SQL、COBOL等。提供重复代码、编码标准、单元测试、代码覆盖率、代码复杂度、潜在Bug、注释和软件设计报告。

##### 基础环境
服务器：
test12：192.168.37.14
系统版本：CentOS Linux release 7.6.1810 (Core)

##### 安装
##### 安装jdk
下载jdk的rpm包，然后安装：rpm -ivh jdk-8u91-linux-x64.rpm

###### 安装mysql
1、下载 mysql57-community-release-el7-8.noarch.rpm 的 YUM 源
wget http://repo.mysql.com/mysql57-community-release-el7-8.noarch.rpm
2、安装 mysql57-community-release-el7-8.noarch.rpm
rpm -ivh mysql57-community-release-el7-8.noarch.rpm
3、安装 MySQL，出现提示的话，一路 Y 到底
yum install mysql-server
4、启动mysql，会在/var/log/mysqld.log 文件中会自动生成一个随机的密码，我们需要先取得这个随机密码
systemctl start mysqld
cat /var/log/mysqld.log | grep password
5、更改一下mysql密码，并要符合密码复杂度
alter user 'root'@'localhost' identified by 'Admin*123123';
6、创建一个sonarqube的数据库
CREATE DATABASE sonar DEFAULT CHARACTER SET utf8;
7、创建sonarqube的用户并赋予sonarqube数据库的权限
grant all privileges on sonarqube.* to sonarqube@"%" identified by "Admin*1212";

##### 安装sonarqube
1、下载sonarqube:
https://binaries.sonarsource.com/Distribution/sonarqube/sonarqube-7.7.zip
2、解压sonarqube到指定目录
unzip sonarqube-7.7.zip
mv sonarqube-7.7 /usr/local/
3、创建sonarqube用户，并更改/usr/local/sonarqube的所有者
useradd sonarqube
chown sonarqube.sonarqube /usr/local/sonarqube -R
4、修改sonarqube的配置文件
```shell
[root@test14 ~]# cat /usr/local/sonarqube-7.7/conf/sonar.properties |grep -vE "^#|^$"
sonar.jdbc.username=sonarqube
sonar.jdbc.password=Admin*1212
sonar.jdbc.url=jdbc:mysql://localhost:3306/sonarqube?useUnicode=true&characterEncoding=utf8&rewriteBatchedStatements=true&useConfigs=maxPerformance&useSSL=false
sonar.web.host=192.168.37.14
#sonar.web.port=9000                   #端口默认是9000，也可以修改成其它
##下面配置ldap认证
sonar.security.realm=LDAP
ldap.url=ldap://192.168.23.12:389
ldap.bindDn=CN=ldapread,OU=Ubox,DC=ubox,DC=ad
ldap.bindPassword=
ldap.user.request=(&(objectClass=person)(sAMAccountName={login}))
ldap.user.baseDn=ou=Ubox,dc=ubox,dc=ad
ldap.user.realNameAttribute=displayName
ldap.user.emailAttribute=mail
##下面组的注释掉也可以，测试发现指定不到固定的某个组
ldap.group.baseDn=CN=nexus-dev,OU=Others,OU=Groups,OU=Ubox,DC=ubox,DC=ad   
ldap.group.request=(&(objectClass=group)(member={dn}))
```
5、启动sonarqube：/usr/local/sonarqube-7.7/bin/liunx-x86-64/sonar.sh start
6、web登录地址：192.168.37.14:9000 管理员默认帐户密码是：admin admin
7、添加中文插件Administrator----->Marketplace------>找到Chinese Pack点击Install，安装完后会提示Restart Server

注意：启动sonarqube需要切换到sonarqube用户下启动，假如在root用户下启动一次后，有一些日志文件所有者就变动了root了，这样即使再切换到sonarqube用户下也启动不了，需要chown sonarqube.sonarqube /usr/local/sonarqube-7.7/